"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _wrapNativeSuper(Class) { var _cache = typeof Map === "function" ? new Map() : undefined; _wrapNativeSuper = function _wrapNativeSuper(Class) { if (Class === null || !_isNativeFunction(Class)) return Class; if (typeof Class !== "function") { throw new TypeError("Super expression must either be null or a function"); } if (typeof _cache !== "undefined") { if (_cache.has(Class)) return _cache.get(Class); _cache.set(Class, Wrapper); } function Wrapper() { return _construct(Class, arguments, _getPrototypeOf(this).constructor); } Wrapper.prototype = Object.create(Class.prototype, { constructor: { value: Wrapper, enumerable: false, writable: true, configurable: true } }); return _setPrototypeOf(Wrapper, Class); }; return _wrapNativeSuper(Class); }

function isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _construct(Parent, args, Class) { if (isNativeReflectConstruct()) { _construct = Reflect.construct; } else { _construct = function _construct(Parent, args, Class) { var a = [null]; a.push.apply(a, args); var Constructor = Function.bind.apply(Parent, a); var instance = new Constructor(); if (Class) _setPrototypeOf(instance, Class.prototype); return instance; }; } return _construct.apply(null, arguments); }

function _isNativeFunction(fn) { return Function.toString.call(fn).indexOf("[native code]") !== -1; }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var formatRequest = function formatRequest(_ref) {
  var method = _ref.method,
      params = _ref.params,
      id = _ref.id,
      options = _ref.options;

  if (!(typeof method === "string")) {
    throw new TypeError("".concat(method, " must be a string"));
  }

  var request = {
    method: method
  }; // assume 2.0 request unless otherwise specified

  if (!options.version || options.version !== 1) {
    request.jsonrpc = "2.0";
  }

  if (params) {
    if (!(params === Object(params)) && !Array.isArray(params) || typeof params === "function") {
      throw new TypeError("".concat(params, " must be an object or array"));
    }

    request.params = params;
  } // assume notification otherwise


  if (!(typeof id === "undefined")) {
    request.id = id;
  }

  var messageString = JSON.stringify(request) + options.delimiter;
  return messageString;
};

var formatResponse = function formatResponse(_ref2) {
  var jsonrpc = _ref2.jsonrpc,
      id = _ref2.id,
      method = _ref2.method,
      result = _ref2.result,
      params = _ref2.params,
      delimiter = _ref2.delimiter;
  var response = {};

  if (params && result) {
    throw new Error("Cannot send response with both params and result");
  }

  if (method && id) {
    throw new Error("Cannot send response with both a method and non-null id");
  }

  if (method && !(typeof method === "string")) {
    throw new TypeError("".concat(method, " must be a string"));
  }

  if (params) {
    if (!(params === Object(params)) && !Array.isArray(params) || typeof params === "function") {
      throw new TypeError("".concat(params, " must be an object or array"));
    }

    response.params = params;
  }

  if (result) {
    response.result = result;
  }

  if (!jsonrpc) {
    // 1.0 response
    response.error = null;
  } else {
    // assume 2.0 response, dont include null error and include jsonrpc version
    response.jsonrpc = "2.0";
  }

  if (!id) {
    if (method) {
      response.method = method;
    }

    if (!jsonrpc) {
      response.id = null;
    }
  } else {
    response.id = id;
  }

  return JSON.stringify(response) + delimiter;
};

var formatError = function formatError(_ref3) {
  var jsonrpc = _ref3.jsonrpc,
      id = _ref3.id,
      code = _ref3.code,
      message = _ref3.message,
      data = _ref3.data,
      delimiter = _ref3.delimiter;

  if (!message) {
    throw new Error("Must include message in error response");
  }

  var response = jsonrpc === "2.0" ? {
    jsonrpc: jsonrpc,
    error: {
      code: code,
      message: message
    },
    id: id
  } : {
    result: null,
    error: {
      code: code,
      message: message
    },
    id: id
  };

  if (data) {
    response.error.data = data;
  }

  return JSON.stringify(response) + delimiter;
};

var BatchRequest =
/*#__PURE__*/
function (_Error) {
  _inherits(BatchRequest, _Error);

  function BatchRequest(message) {
    var _this;

    var request = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : undefined;

    _classCallCheck(this, BatchRequest);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(BatchRequest).call(this, message));
    _this.name = "BatchRequest";
    _this.request = request;
    return _this;
  }

  return BatchRequest;
}(_wrapNativeSuper(Error));

module.exports = {
  formatRequest: formatRequest,
  formatResponse: formatResponse,
  formatError: formatError,
  BatchRequest: BatchRequest
};